                                                             (* 13.3.1999 *)
{
  Quelle:
  Eva Breunig,Wien: Die Formel von Brahmagupta oder das Problem des optimalen
                    Hasenstalles
  in Wissenschaftliche Nachrichten p. 25 - 27   Nr.109 Jaenner 1999 BMUK

  geg: allgemeines Viereck : Punkte A,B,C,D.   Es muss nicht konvex sein !
       aber nicht ueberlappend.
  ges: Flaeche des Vierecks nach Brahmagupta
                            mit 2 Dreiecken zur Bestaetigung gerechnet
  Die zwei Winkeln muessen gegenueberliegen.
  Welches Winkelpaar man nimmt ist an sich gleichgueltig.

  Die Orientierung der Punkte des Vierecks gegen den Uhrzeigersinn
  anordnen, sonst falsche Winkel !!
}
{$N+}
PROGRAM brahma1;
USES CRT,GRAPH,UNIGRA12,Vector1;

VAR
A,B,C,D     : Pt2D;                                      (* ViereckPunkte *)
sa,sb,sc,sd : EXTENDED;                                  (* Seitenlaengen *)
s           : EXTENDED;                  (* halbe Summe der Seitenlaengen *)
alpha,beta,                                                     (* Winkel *)
gamma,delta : EXTENDED;
Flaeche     : EXTENDED;                       (* Flaeche nach Brahmagupta *)

ha,hDB      : EXTENDED;                (* Hoehe auf DB, Hoehe auf Seite a *)
FABD,FDBC   : EXTENDED;                       (* Flaeche der Teildreiecke *)
FDreiecke   : EXTENDED;                     (* Summe der Dreiecksflaechen *)

{ ------------------------- Unterprogramme ------------------------------- }
Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('');
   Weltgrenzen_festlegen(einh);  
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Portrait  := FALSE;                   (* Querformat Bild liegend        *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;
   Viewport_zeichnen; 
   Koordinatenachsen_zeichnen;
   Gitter(0.1,1.0,10.0);  (* Strich,              klE,             grE     *)
                        (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

Procedure Beschriftung;
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS,SXS,SYS: STRING[Bz1];
  BXS,BYS,DXS,DYS,AXS,AYS,CXS,CYS                : STRING[Bz1];
  Ttemp1,Ttemp2                                  : STRING[Bz2];
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:3,einhS);
  STR(A.X:5:3,AXS); STR(A.Y:5:3,AYS);
  STR(B.X:5:3,BXS); STR(B.Y:5:3,BYS);
  STR(C.X:5:3,CXS); STR(C.Y:5:3,CYS);
  STR(D.X:5:3,DXS); STR(D.Y:5:3,DYS);

(* ----------------------------- TEXTE --------------------------------- *)
  Ttemp1 := 'geg: allgemeines Viereck:';
  Ttemp2 := '';
  T[1] := Ttemp1 + Ttemp2;
  T[2] := '     A('+AXS+'/'+AYS+')   B('+BXS+'/'+BYS+')   C('+CXS+'/'+CYS+')';
  Ttemp1 := 'ges: Flaeche des Vierecks nach Brahmagupta:';
  Ttemp2 := ' ';
  T[3] := Ttemp1 + Ttemp2;
  Ttemp1 := '     A^2 = (s-a)(s-b)(s-c)(s-d) - abcd*cos^2((alpha + Gamma)/2)';
  Ttemp2 := '';
  T[4] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[5] := Ttemp1 + Ttemp2;
  T[6] := '1 Einheit entspricht '+einhS+'  cm';
  
  Text_ausgeben(T,6);                                 (* .. Texte ausgeben *)
  END;

PROCEDURE Eingabe;
  BEGIN
    A.X := -10.8;  A.Y :=  -7.5;                    (* Punkte des Vierecks *)
    B.X :=  10.1;  B.Y :=  -5.1;
    C.X :=   6.3;  C.Y :=   2.9;
    D.X := -11.7;  D.Y :=   4.4;
  END;

PROCEDURE Seitenlaengen;
VAR
V : Vt2D;
BEGIN
  MakeVt2D(A,B,V);
  LengthVt2D(V,sa);
  MakeVt2D(B,C,V);
  LengthVt2D(V,sb);
  MakeVt2D(C,D,V);
  LengthVt2D(V,sc);
  MakeVt2D(D,A,V);
  LengthVt2D(V,sd);
  s := (sa + sb + sc + sd)/2.0;
END;

PROCEDURE Winkelberechnen;
VAR
V1,V2 : Vt2D;
BEGIN
  MakeVt2D(A,B,V1);
  MakeVt2D(A,D,V2);
  AngleBetweenVts2D(V1,V2,alpha);
  IF alpha <= 0.0 THEN alpha := 2.0*PI + alpha;
  MakeVt2D(B,C,V1);
  MakeVt2D(B,A,V2);
  AngleBetweenVts2D(V1,V2,beta);
  IF beta <= 0.0 THEN beta := 2.0*PI + beta;
  MakeVt2D(C,D,V1);
  MakeVt2D(C,B,V2);
  AngleBetweenVts2D(V1,V2,gamma);
  IF gamma <= 0.0 THEN gamma := 2.0*PI + gamma;
  MakeVt2D(D,A,V1);
  MakeVt2D(D,C,V2);
  AngleBetweenVts2D(V1,V2,delta);
  IF delta <= 0.0 THEN delta := 2.0*PI + delta;
END;

PROCEDURE Flaecheberechnen;
VAR
H1,H2,H3,H4,COS2 : EXTENDED;
BEGIN
  H1 := (s-sa)*(s-sb)*(s-sc)*(s-sd);
  H2 := sa*sb*sc*sd;
  COS2 := COS((alpha+gamma)/2.0) * COS((alpha+gamma)/2.0);
  H3 := H2*COS2;
  H4 := H1 - H2*COS2;
  Flaeche := SQRT(H4);
END;

PROCEDURE ViereckZeichnen;
  BEGIN
    NormLinie;
    MovetoPt2D(A);
    DrawtoPt2D(B,15); DrawtoPt2D(C,15);  DrawtoPt2D(D,15);  DrawtoPt2D(A,15);
    SETCOLOR(7);
    OutTextXY2D(A,' A'); OutTextXY2D(B,' B'); 
    OutTextXY2D(C,' C'); OutTextXY2D(D,' D');
    Hilfslinie2;
    DrawLine2D(B,D,2);
    NormLinie;
  END;

PROCEDURE FlaechemitDreiecken;
VAR
lAB,lDB : Line2D;
V : Vt2D;
sDB : EXTENDED;
BEGIN
  MakeLine2D(A,B,lAB);
  NormDistance(lAB,D,ha);
  IF ha < 0.0 THEN ha := -ha;        { Normdistanz ist negativ, wenn Punkt }
  MakeLine2D(D,B,lDB);               { und Gerade auf verschiedenen Seiten }
  NormDistance(lDB,C,hDB);           { des Ursprungs liegen !!!!           }
  IF hDB < 0.0 THEN hDB := -hDB;     { positiv, wenn auf gleicher Seite    }
  FABD := sa*ha/2.0;
  MakeVt2D(D,B,V);
  LengthVt2D(V,sDB);
  FDBC := sDB*hDB/2.0;
  IF alpha > PI THEN FABD := -FABD;
  IF gamma > PI THEN FDBC := -FDBC;
  FDreiecke := FABD + FDBC;
END;

PROCEDURE Ausgabe;
VAR
Grad : EXTENDED;
BEGIN
  Grad :=  180.0/PI;
  WRITELN('Punkte:');
  WRITELN('A(',A.X:5:1,' / ',A.Y:5:1,')');
  WRITELN('B(',B.X:5:1,' / ',B.Y:5:1,')');
  WRITELN('C(',C.X:5:1,' / ',C.Y:5:1,')');
  WRITELN('D(',D.X:5:1,' / ',D.Y:5:1,')');
  WRITELN('Seiten:');
  WRITELN('Seite a: ',sa:5:1);
  WRITELN('Seite b: ',sb:5:1);
  WRITELN('Seite c: ',sc:5:1);
  WRITELN('Seite d: ',sd:5:1);
  WRITELN('s      : ',s:5:1);
  WRITELN;
  WRITELN('Winkeln:');
  WRITELN('Alpha  : ',alpha*Grad:6:1);
  WRITELN('Beta   : ',beta*Grad:6:1);
  WRITELN('Gamma  : ',gamma*Grad:6:1);
  WRITELN('Delta  : ',delta*Grad:6:1);
  WRITELN;
  WRITELN('Hoehe auf a  : ',ha:5:1);
  WRITELN('Hoehe auf DB : ',hDB:5:1);
  WRITELN;
  WRITELN('Dreieck ABD: ',FABD:7:1,'   Dreieck DBC: ',FDBC:7:1);
  WRITELN('Flaeche nach Brahmagupta : ',Flaeche:6:1);
  WRITELN('Flaeche mit Dreiecken    : ',FDreiecke:6:1);
  READLN;
END;

{ -------------------------- Hauptprogramm -------------------------------- }
BEGIN
  Schnittstelle_waehlen(1);                (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;                           (* 1 ist parallele Schnittst    *)
  einh := 1.0;   (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  WI2D[1].X := -14.0;                          (* linker unterer Punkt     *)
  WI2D[1].Y := -8.0;                           (* des Weltfensters         *)

  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Eingabe;
  Seitenlaengen;
  Winkelberechnen;
  Flaecheberechnen;
  FlaechemitDreiecken;
  ViereckZeichnen;
  Beschriftung;
  WClosegraph;
  Ausgabe;
END.